# Class NetworkInterface

java.lang.Object
java.net.NetworkInterface

public final class NetworkInterface extends Object
This class represents a Network Interface.

A Network Interface is an abstraction encapsulating the characteristics of a Network Interface Controller, or Virtual Network adapter, which is a system hardware/software component connecting a computer, or host system, to a computer network. A Network Interface can be physical or virtual. A Network Interface has a name, zero or more assigned IP addresses, zero or more MAC Addresses, and may have an index. The name is highly platform specific but a name such as "le0" is typical; it may not be unique. The index is a highly platform specific number that identifies the interface. The network configuration may change during the lifetime of the JVM. For example, the set of IP addresses assigned to a network interface can be transient and dynamically allocated, and may change at any time.

When obtaining a `NetworkInterface` instance, part of its configuration (such as its name and the list of assigned IP addresses), is reflective of its configuration at creation time. Obtaining an updated view of the network configuration may require looking up a network interface again in order to obtain a new instance.

Network interface instances are typically used to identify the local interface on which a multicast group is joined.

API Note:
  Several static methods in this class are factory methods, returning a new instance of a `NetworkInterface`, reflecting the configuration at the time of instantiation. The network configuration may change at any time, and as such, these methods may need to be invoked again in order to obtain a more up-to-date view of the network interfaces. In particular, there is no guarantee that the same interface will be found at the same index, or that the same network addresses will be bound to the interface, if the network configuration of the system has changed.
Since:
  1.4

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Compares this object against the specified object.
`static NetworkInterface`
`getByIndex(int index)`
Get a network interface given its index.
`static NetworkInterface`
`getByInetAddress(InetAddress addr)`
Convenience method to search for a network interface that has the specified Internet Protocol (IP) address bound to it.
`static NetworkInterface`
`getByName(String name)`
Searches for the network interface with the specified name.
`String`
`getDisplayName()`
Get the display name of this network interface.
`byte[]`
`getHardwareAddress()`
Returns the hardware address (usually MAC) of the interface if it has one and if it can be accessed given the current privileges.
`int`
`getIndex()`
Returns the index of this network interface.
`Enumeration<InetAddress>`
`getInetAddresses()`
Get an Enumeration of the InetAddresses bound to this network interface.
`List<InterfaceAddress>`
`getInterfaceAddresses()`
Get a List of the `InterfaceAddresses` of this network interface.
`int`
`getMTU()`
Returns the Maximum Transmission Unit (MTU) of this interface.
`String`
`getName()`
Get the name of this network interface.
`static Enumeration<NetworkInterface>`
`getNetworkInterfaces()`
Returns an `Enumeration` of all the interfaces on this machine.
`NetworkInterface`
`getParent()`
Returns the parent NetworkInterface of this interface if this is a subinterface, or `null` if it is a physical (non virtual) interface or has no parent.
`Enumeration<NetworkInterface>`
`getSubInterfaces()`
Get an Enumeration with all the subinterfaces (also known as virtual interfaces) attached to this network interface.
`Stream<InetAddress>`
`inetAddresses()`
Get a Stream of the InetAddresses bound to this network interface.
`boolean`
`isLoopback()`
Returns whether a network interface is a loopback interface.
`boolean`
`isPointToPoint()`
Returns whether a network interface is a point to point interface.
`boolean`
`isUp()`
Returns whether a network interface is up and running.
`boolean`
`isVirtual()`
Returns whether this interface is a virtual interface (also called subinterface).
`static Stream<NetworkInterface>`
`networkInterfaces()`
Returns a `Stream` of all the interfaces on this machine.
`Stream<NetworkInterface>`
`subInterfaces()`
Get a Stream of all subinterfaces (also known as virtual interfaces) attached to this network interface.
`boolean`
`supportsMulticast()`
Returns whether a network interface supports multicasting or not.

### Methods declared in class Object

`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getName

public String getName()
Get the name of this network interface.

Returns:
  the name of this network interface

### getInetAddresses

public Enumeration<InetAddress> getInetAddresses()
Get an Enumeration of the InetAddresses bound to this network interface.

Implementation Note:
  The returned enumeration contains the InetAddresses that were bound to the interface at the time the interface configuration was read
Returns:
  an Enumeration object with the InetAddresses bound to this network interface
See Also:
  - `inetAddresses()`

### inetAddresses

public Stream<InetAddress> inetAddresses()
Get a Stream of the InetAddresses bound to this network interface.

Implementation Note:
  The stream contains the InetAddresses that were bound to the interface at the time the interface configuration was read
Returns:
  a Stream object with the InetAddresses bound to this network interface
Since:
  9

### getInterfaceAddresses

public List<InterfaceAddress> getInterfaceAddresses()
Get a List of the `InterfaceAddresses` of this network interface.

Returns:
  a `List` object with the InterfaceAddress of this network interface
Since:
  1.6

### getSubInterfaces

public Enumeration<NetworkInterface> getSubInterfaces()
Get an Enumeration with all the subinterfaces (also known as virtual interfaces) attached to this network interface.

For instance eth0:1 will be a subinterface to eth0.

Returns:
  an Enumeration object with all of the subinterfaces of this network interface
Since:
  1.6
See Also:
  - `subInterfaces()`

### subInterfaces

public Stream<NetworkInterface> subInterfaces()
Get a Stream of all subinterfaces (also known as virtual interfaces) attached to this network interface.

Returns:
  a Stream object with all of the subinterfaces of this network interface
Since:
  9

### getParent

public NetworkInterface getParent()
Returns the parent NetworkInterface of this interface if this is a subinterface, or `null` if it is a physical (non virtual) interface or has no parent.

Returns:
  The `NetworkInterface` this interface is attached to.
Since:
  1.6

### getIndex

public int getIndex()
Returns the index of this network interface. The index is an integer greater or equal to zero, or `-1` for unknown. This is a system specific value and interfaces with the same name can have different indexes on different machines.

Returns:
  the index of this network interface or `-1` if the index is unknown
Since:
  1.7
See Also:
  - `getByIndex(int)`

### getDisplayName

public String getDisplayName()
Get the display name of this network interface. A display name is a human readable String describing the network device.

Returns:
  a non-empty string representing the display name of this network interface, or null if no display name is available.

### getByName

public static NetworkInterface getByName(String name) throws SocketException
Searches for the network interface with the specified name.

API Note:
  The returned interface instance may reflect a snapshot of the configuration taken at the time the instance is created. See the general discussion of snapshots and configuration for the semantics of the returned interface.
Parameters:
  `name` - The name of the network interface.
Returns:
  A `NetworkInterface` with the specified name, or `null` if there is no network interface with the specified name.
Throws:
  `SocketException` - If an I/O error occurs.
  `NullPointerException` - If the specified name is `null`.

### getByIndex

public static NetworkInterface getByIndex(int index) throws SocketException
Get a network interface given its index.

API Note:
  The returned interface instance may reflect a snapshot of the configuration taken at the time the instance is created. See the general discussion of snapshots and configuration for the semantics of the returned interface.
Parameters:
  `index` - an integer, the index of the interface
Returns:
  the NetworkInterface obtained from its index, or `null` if there is no interface with such an index on the system
Throws:
  `SocketException` - if an I/O error occurs.
  `IllegalArgumentException` - if index has a negative value
Since:
  1.7
See Also:
  - `getIndex()`

### getByInetAddress

public static NetworkInterface getByInetAddress(InetAddress addr) throws SocketException
Convenience method to search for a network interface that has the specified Internet Protocol (IP) address bound to it.

If the specified IP address is bound to multiple network interfaces it is not defined which network interface is returned.

API Note:
  The returned interface instance may reflect a snapshot of the configuration taken at the time the instance is created. See the general discussion of snapshots and configuration for the semantics of the returned interface.
Parameters:
  `addr` - The `InetAddress` to search with.
Returns:
  A `NetworkInterface` or `null` if there is no network interface with the specified IP address.
Throws:
  `SocketException` - If an I/O error occurs.
  `NullPointerException` - If the specified address is `null`.

### getNetworkInterfaces

public static Enumeration<NetworkInterface> getNetworkInterfaces() throws SocketException
Returns an `Enumeration` of all the interfaces on this machine. The `Enumeration` contains at least one element, possibly representing a loopback interface that only supports communication between entities on this machine.

API Note:
  This method can be used in combination with `getInetAddresses()` to obtain all IP addresses for this node.

  The returned interface instances may reflect a snapshot of the configuration taken at the time the instance is created. See the general discussion of snapshots and configuration for the semantics of the returned interface.

Returns:
  an Enumeration of NetworkInterfaces found on this machine
Throws:
  `SocketException` - if an I/O error occurs, or if the platform does not have at least one configured network interface.
See Also:
  - `networkInterfaces()`

### networkInterfaces

public static Stream<NetworkInterface> networkInterfaces() throws SocketException
Returns a `Stream` of all the interfaces on this machine. The `Stream` contains at least one interface, possibly representing a loopback interface that only supports communication between entities on this machine.

API Note:
  This method can be used in combination with `inetAddresses()` to obtain a stream of all IP addresses for this node, for example:

      Stream<InetAddress> addrs = NetworkInterface.networkInterfaces()
          .flatMap(NetworkInterface::inetAddresses);

  The returned interface instances may reflect a snapshot of the configuration taken at the time the instance is created. See the general discussion of snapshots and configuration for the semantics of the returned interface.

Returns:
  a Stream of NetworkInterfaces found on this machine
Throws:
  `SocketException` - if an I/O error occurs, or if the platform does not have at least one configured network interface.
Since:
  9

### isUp

public boolean isUp() throws SocketException
Returns whether a network interface is up and running.

Returns:
  `true` if the interface is up and running.
Throws:
  `SocketException` - if an I/O error occurs.
Since:
  1.6

### isLoopback

public boolean isLoopback() throws SocketException
Returns whether a network interface is a loopback interface.

Returns:
  `true` if the interface is a loopback interface.
Throws:
  `SocketException` - if an I/O error occurs.
Since:
  1.6

### isPointToPoint

public boolean isPointToPoint() throws SocketException
Returns whether a network interface is a point to point interface. A typical point to point interface would be a PPP connection through a modem.

Returns:
  `true` if the interface is a point to point interface.
Throws:
  `SocketException` - if an I/O error occurs.
Since:
  1.6

### supportsMulticast

public boolean supportsMulticast() throws SocketException
Returns whether a network interface supports multicasting or not.

Returns:
  `true` if the interface supports Multicasting.
Throws:
  `SocketException` - if an I/O error occurs.
Since:
  1.6

### getHardwareAddress

public byte[] getHardwareAddress() throws SocketException
Returns the hardware address (usually MAC) of the interface if it has one and if it can be accessed given the current privileges.

Returns:
  a byte array containing the address, or `null` if the address doesn't exist or is not accessible
Throws:
  `SocketException` - if an I/O error occurs.
Since:
  1.6

### getMTU

public int getMTU() throws SocketException
Returns the Maximum Transmission Unit (MTU) of this interface.

Returns:
  the value of the MTU for that interface.
Throws:
  `SocketException` - if an I/O error occurs.
Since:
  1.6

### isVirtual

public boolean isVirtual()
Returns whether this interface is a virtual interface (also called subinterface). Virtual interfaces are, on some systems, interfaces created as a child of a physical interface and given different settings (like address or MTU). Usually the name of the interface will the name of the parent followed by a colon (:) and a number identifying the child since there can be several virtual interfaces attached to a single physical interface.

Returns:
  `true` if this interface is a virtual interface.
Since:
  1.6

### equals

public boolean equals(Object obj)
Compares this object against the specified object. The result is `true` if and only if the argument is not `null` and it represents the same NetworkInterface as this object.

Two instances of `NetworkInterface` represent the same NetworkInterface if both the name and the set of `InetAddress`es bound to the interfaces are equal.

Overrides:
  `equals` in class `Object`
API Note:
  two `NetworkInterface` objects referring to the same underlying interface may not compare equal if the addresses of the underlying interface are being dynamically updated by the system.
Parameters:
  `obj` - the object to compare against.
Returns:
  `true` if the objects are the same; `false` otherwise.
See Also:
  - `InetAddress.getAddress()`